/*
 * @(#)glut_menu.java 0.1 01/04/20
 *
 * jGL 3-D graphics library for Java
 * Copyright (c) 2001 Robin Bing-Yu Chen (robin@is.s.u-tokyo.ac.jp)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version. the GNU Lesser
 * General Public License should be included with this distribution
 * in the file LICENSE.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */

package jgl.glut;

import java.awt.Component;
import java.awt.Menu;
import java.awt.MenuItem;
import java.awt.PopupMenu;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.lang.IllegalAccessException;
import java.lang.Integer;
import java.lang.NoSuchMethodException;
import java.lang.Object;
import java.lang.String;
import java.lang.System;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.Hashtable;

/**
 * glut_menu is menu object of the GLUT class of jGL 2.4.
 *
 * @version 	0.1, 20 Apr 2001
 * @author 	Robin Bing-Yu Chen
 */

public class glut_menu implements ActionListener {

    private Method menuMethod = null;
    private PopupMenu JavaMenu = null;
    private Hashtable JavaMenuItem = null;
    private int menuID = 0;
    
    private Component JavaComponent = null;

    public void actionPerformed (ActionEvent e) {
	Object[] arguments = new Object[] { JavaMenuItem.get(e.getActionCommand()) };
	try {
	    menuMethod.invoke(JavaComponent, arguments);
	} catch (IllegalAccessException ee) {
	    System.out.println(ee);
	} catch (InvocationTargetException ee) {
	    System.out.println(ee);
	}
    }

    public void glutAddMenuEntry (String label, int value) {
	MenuItem mi = new MenuItem (label);
	mi.addActionListener (this);
	JavaMenuItem.put (label, new Integer (value));
	JavaMenu.add (mi);
    }

    public void glutAddSubMenu (String label, glut_menu submenu) {
	submenu.JavaMenu.setLabel (label);
	JavaMenu.add (submenu.JavaMenu);
    }
    
    public void glutRemoveMenuItem (int item) {
	JavaMenu.remove (item);
    }
    
    public void glutDestroyMenu () {
	menuMethod = null;
	JavaMenu = null;
	JavaMenuItem = null;
	menuID = 0;
	JavaComponent = null;
    }
    
    public int glutGetMenuID () {
	return menuID;
    }

    public PopupMenu glutGetMenu () {
	return JavaMenu;
    }

    public glut_menu (String func, int id, Component comp) {
	if (func != null) {
	    Class[] parameterTypes = new Class[] { int.class };
	    try {
		menuMethod = comp.getClass().getMethod(func, parameterTypes);
		JavaMenu = new PopupMenu ();
		JavaMenuItem = new Hashtable ();
		menuID = id;
		JavaComponent = comp;
	    } catch (NoSuchMethodException e) {
		System.out.println ("No method named "+func);
	    }
/*
	} else {
	    menuMethod = null;
	    JavaMenu = null;
	    JavaMenuItem = null;
	    menuID = 0:
*/
	}
    }

}

